package habibviewer.guielements;

/**
 * Class:           habibviewer.guielements.FileInfoPanel
 * Version:         0.?
 * Date:            2004-01-18 16:12:06
 *
 * Description:     ?
 *
 * COPYRIGHT:
 *
 * This software module was originally developed by Pawe Haasa.
 *
 */

import java.awt.*;
import javax.swing.*;

/**
 * This class represents panel whitch contains informations about loaded file
 * such as file name, size, resolution, bitrate ect.*/
public class FileInfoPanel extends JPanel {

    private TextField fileNameField;
    private Label size, resolution, bitrate;
    private TextArea info;

    /** Button next to file name field
     *
     * @see Button*/
    public Button chooseButton;

    /** Creates and shows a panel */
    public FileInfoPanel() {
        setBorder(BorderFactory.createTitledBorder("File information"));
        Box box = Box.createVerticalBox();
        box.setAlignmentX(LEFT_ALIGNMENT);
        add(box);

        // fileNameField + chooseButton = fileBox
        Box fileBox = Box.createHorizontalBox();
        box.add(fileBox);
        fileNameField = new TextField("", 20);
        fileNameField.setEditable(false);
        fileBox.add(fileNameField);
        fileBox.add(Box.createHorizontalStrut(5));
        chooseButton = new Button("...");
        fileBox.add(chooseButton);

        box.add(Box.createVerticalStrut(15));

        size = new Label("Size: ?");
        box.add(size);
        resolution = new Label("Resolution: ?");
        box.add(resolution);
        bitrate = new Label("Target bitrate: ?");
        box.add(bitrate);

        Label addInfo = new Label("Additional informations:");
        box.add(addInfo);
        info = new TextArea(6, 25);
        info.setEditable(false);
        box.add(info);
    }

    /** Updates file informations
     *
     * @param fileName Full file path
     *
     * @param fileSize Size of the file
     *
     * @param imgWidth Width of displayed image
     *
     * @param imgHeight Height of displayed image
     *
     * @param rate Decoding rate in bits per pixel
     *
     * @param inf Additional informations*/
    public void updateInfo(String fileName, long fileSize, int imgWidth, int imgHeight, float rate, String inf) {

        fileNameField.setText(fileName);
        if (fileSize > 0)
            size.setText("Size: " + String.valueOf(fileSize));
        else
            size.setText("Size: ?");

        if (imgWidth > 0 && imgHeight > 0)
            resolution.setText("Resolution: " + String.valueOf(imgWidth) + " x " + String.valueOf(imgHeight));
        else
            resolution.setText("Resolution: ?");

        if (rate > 0)
            bitrate.setText("Target bitrate: " + (float)Math.round(1000*rate)/1000);
        else
            bitrate.setText("Target bitrate: ?");

        info.setText(inf);
    }
}
