package habibviewer.guielements;

/**
 * Class:           habibviewer.guielements.ImageArea
 * Version:         0.?
 * Date:            2004-01-20 21:01:56
 *
 * Description:     ?
 *
 * COPYRIGHT:
 *
 * This software module was originally developed by Pawe? Ha?asa.
 * 
 */

import jj2000.disp.*;
import java.awt.event.*;

/**
 * This class implements an image viewer that can display an image larger than
 * the actual display area, and presents scrollbars to scroll the viewable
 * area. This class also supports zooming in and out the image, with no extra
 * memory requirements.
 *
 * This class creates main frame of program, whitch contains image area, menu
 * bar and settings panel.
 *
 * <P>Accepted file formats are: JPEG, JPEG2000, GIF, PNG, PPM and PGM.
 *
 * @see jj2000.disp.ImgScrollPane
 * */
public class ImageArea extends ImgScrollPane implements MouseWheelListener, KeyListener {

    private float zoomRatio = 0.25f;

    /* Creates area for the images and adds the listeners */
    public ImageArea() {
        addMouseWheelListener(this);
        addKeyListener(this);
        //imageUpdate(getImage(), 0, 0, 0, 0, 0);
    }

    public void mouseWheelMoved(MouseWheelEvent e) {
        int notches = e.getWheelRotation();

        if (notches < 0) {
            zoomOut();
        } else {
            zoomIn();
        }
    }

    /** Zoom in
     * @see zoom*/
    public void zoomIn() {
        zoom(1 + zoomRatio);
        validate();
    }

    /** Zoom out
     * @see zoom*/
    public void zoomOut() {
        zoom(1/(1 + zoomRatio));
        validate();
    }

    public void keyTyped(KeyEvent e) {
    }

    public void keyPressed(KeyEvent e) {
        int code = e.getKeyCode();

        if (code == KeyEvent.VK_PLUS) {
            zoomIn();
        } else if (code == KeyEvent.VK_MINUS) {
            zoomOut();
        }
    }

    public void keyReleased(KeyEvent e) {
    }
}
