package habibviewer.guielements.dialogs;

/**
 * Class:           habibviewer.guielements.dialogs.AboutProgramDialog
 * Version:         0.5
 * Date:            2004-01-18 16:16:09
 *
 * Description:     ?
 *
 * COPYRIGHT:
 *
 * This software module was originally developed by Pawe Haasa.
 *
 */

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;

public class AboutProgramDialog extends Dialog implements ActionListener {
    static String info = "Habib JPEG2000 Viewer v. 0.2\n" +
            "Copyright by Pawel Halasa (2004)\n\n" +
            "The JJ2000 copyright notice is included\n" +
            "in COPYRIGHT file.";
    Button confirm;

    public AboutProgramDialog(Frame parent) {
        super(parent, "About program", true);
        setSize(300, 220);
        setLocationRelativeTo(parent);
        setResizable(false);

        JPanel p1 = new JPanel();
        p1.setBorder(new EmptyBorder(10, 10, 10, 10));
        add(p1);

        Box box = Box.createVerticalBox();
        p1.add(box);

        TextArea info = new TextArea(this.info, 8, 35, TextArea.SCROLLBARS_VERTICAL_ONLY);
        info.setEditable(false);
        box.add(info);

        Panel buttonPanel = new Panel();
        box.add(buttonPanel);
        confirm = new Button("      OK      ");
        confirm.addActionListener(this);
        buttonPanel.add(confirm);

        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent evt) {
                dispose();
            }
        });

        show();
        validate();
    }

    public void actionPerformed(ActionEvent ae) {
        if (ae.getSource() == confirm) {
            dispose();
        }
    }
}
