/**
 * Class:           JPEG2000FileFilter
 * Version:         0.?
 * Date:            2004-01-18 16:06:35
 *
 * Description:     Accepts all directories, PGM and PPM files.
 *
 * COPYRIGHT:
 *
 * This software module was originally developed by Pawe Haasa.
 *
 */

package habibviewer.guielements.filefilters;

import java.io.File;

public class AllImagesFileFilter extends javax.swing.filechooser.FileFilter {

    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        String extension = f.getName().toLowerCase();
        if (extension != null) {
            if (extension.endsWith(".jpg") || extension.endsWith(".jpeg") ||
                    extension.endsWith(".jpe") || extension.endsWith(".jfif") ||
                    extension.endsWith(".gif") || extension.endsWith(".png") ||
                    extension.endsWith(".jp2") || extension.endsWith(".jpc") ||
                    extension.endsWith(".habibviewer.pgm") || extension.endsWith(".habibviewer.ppm")) {
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    public String getDescription() {
        return "All image files";
    }
}
