/**
 * Class:           JPEG2000FileFilter
 * Version:         0.9
 * Date:            2004-01-18 16:06:35
 *
 * Description:     Accepts all directories and JPEG files.
 *
 * COPYRIGHT:
 *
 * This software module was originally developed by Pawe Haasa.
 *
 */

package habibviewer.guielements.filefilters;

import java.io.File;

public class JPEGFileFilter extends javax.swing.filechooser.FileFilter {

    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        String extension = f.getName().toLowerCase();
        if (extension != null) {
            if (extension.endsWith(".jpg") ||
                extension.endsWith(".jpeg")||
                extension.endsWith(".jpe") ||
                extension.endsWith(".jfif")){
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    public String getDescription() {
        return "JPEG (*.JPG;*.JPEG;*.JPE;*.JFIF)";
    }
}
