/**
 * Class:           JPEG2000FileFilter
 * Version:         0.?
 * Date:            2004-01-18 16:06:35
 *
 * Description:     Accepts all directories and PPM files.
 *
 * COPYRIGHT:
 *
 * This software module was originally developed by Pawe Haasa.
 *
 */

package habibviewer.guielements.filefilters;

import java.io.File;

public class PPMFileFilter extends javax.swing.filechooser.FileFilter {

    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }
        String extension = f.getName().toLowerCase();
        if (extension != null) {
            if (extension.endsWith(".habibviewer.ppm")) {
                return true;
            } else {
                return false;
            }
        }
        return false;
    }

    public String getDescription() {
        return "PPM (*.PPM)";
    }
}
