package habibviewer.pgm;

/**
 * Class:           habibviewer.pgm.PGMImage
 * Version:         0.?
 * Date:            2004-01-21 01:24:30
 *
 * Description:     ?
 *
 * COPYRIGHT:
 *
 * This software module was originally developed by Pawe? Ha?asa.
 * 
 */

import java.awt.*;
import java.awt.image.*;
import java.io.*;
import java.lang.String;

public class PGMImage implements ImageConsumer {
    private int wys, szer;
    private ImageProducer producer;
    private byte[] Data = null;
    private boolean flag = false;

    public PGMImage(Image img) {
        producer = img.getSource();
    }

    public static Image load(String PGMfile) {
        File f = new File(PGMfile);
        FileInputStream in;

        Image img = null;
        int xres = 0, yres = 0, maxGray = 0;
        try {
            in = new FileInputStream(f);
        } catch (IOException e) {
            return null;
        }
        try {
            StreamTokenizer st = new StreamTokenizer(new InputStreamReader(in));
            st.commentChar('#');
            st.eolIsSignificant(true);
            st.nextToken();
            if (!(st.sval.equals("P5"))) {
                // Unsupported PGM version
                return null;
            }
            if (st.nextToken() == StreamTokenizer.TT_NUMBER)
                xres = (int) st.nval;
            else {
                while (st.nextToken() != StreamTokenizer.TT_NUMBER) {
                }
                xres = (int) st.nval;
            }
            if (st.nextToken() == StreamTokenizer.TT_NUMBER)
                yres = (int) st.nval;
            else {
                while (st.nextToken() != StreamTokenizer.TT_NUMBER) {
                }
                yres = (int) st.nval;
            }
            if (st.nextToken() == StreamTokenizer.TT_NUMBER)
                maxGray = (int) st.nval;
            else {
                while (st.nextToken() != StreamTokenizer.TT_NUMBER) {
                }
                maxGray = (int) st.nval;
            }
            while (st.nextToken() != StreamTokenizer.TT_EOL) {
            }

            byte data[] = new byte[xres * yres];
            in.read(data);
            ColorModelPGM cm = new ColorModelPGM(maxGray);
            img = (new Canvas()).createImage(new MemoryImageSource(xres, yres, cm, data, 0, xres));
        } catch (Exception e) {
            return null;
        }
        return img;
    }

    public boolean save(String PGMfile) {
        producer.startProduction(this);
        while (!this.flag) {
            try {
                Thread.sleep(200);
            } catch (InterruptedException ie) {
            }
        }
        File f = new File(PGMfile);
        FileOutputStream out = null;
        try {
            out = new FileOutputStream(f);
        } catch (IOException e) {
            return false;
        }
        try {
            out.write("P5\n#Created by ImageViewer\n".getBytes());
            out.write(String.valueOf(szer).getBytes());
            out.write(" ".getBytes());
            out.write(String.valueOf(wys).getBytes());
            out.write("\n255\n".getBytes());
            out.write(Data);
            out.close();
        } catch (IOException e) {
            try {
                out.close();
            } catch (IOException ioe) {
            }
            return false;
        }
        return true;
    }

    public void setDimensions(int width, int height) {
        wys = height;
        szer = width;
        Data = new byte[wys * szer];
    }

    public void setProperties(java.util.Hashtable props) {
    }

    public void setColorModel(ColorModel model) {
    }

    public void setHints(int hintflag) {
    }

    public void setPixels(int x, int y, int w, int h, ColorModel model, byte pixels[], int off, int scansize) {
        for (int i = 0; i < h; i++) {
            for (int j = 0; j < w; j++) {
                int pix = (int) (pixels[i * scansize + j + off]);
                Data[(y + i) * szer + x + j] = (byte) ((model.getBlue(pix) +
                        model.getGreen(pix) +
                        model.getRed(pix)) / 3);
            }
        }
    }

    public void setPixels(int x, int y, int w, int h, ColorModel model, int pixels[], int off, int scansize) {
        for (int i = 0; i < h; i++) {
            for (int j = 0; j < w; j++) {
                int pix = pixels[i * scansize + j + off];
                Data[(y + i) * szer + x + j] = (byte) ((model.getBlue(pix) +
                        model.getGreen(pix) +
                        model.getRed(pix)) / 3);
            }
        }
    }

    public void imageComplete(int status) {
        switch (status) {
            case IMAGEABORTED:
                flag = true;
                break;
            case STATICIMAGEDONE:
                flag = true;
                break;
            case SINGLEFRAMEDONE:
                flag = true;
                break;
            case IMAGEERROR:
                flag = true;
                break;
            default:
                break;
        }
        producer.removeConsumer(this);
    }
}

